Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkMPIController Class Reference

`#include <vtkMPIController.h>`

Inheritance diagram for vtkMPIController:

[legend]
Collaboration diagram for vtkMPIController:

[legend]
List of all members.

## Detailed Description

Process communication using MPI.

Date:
  2002/08/12 15:20:30

Revision:
  1.16

vtkMPIController is a concrete class which implements the abstract multi-process control methods defined in vtkMultiProcessController using MPI (Message Passing Interface) cf. Using MPI / Portable Parallel Programming with the Message-Passing Interface, Gropp et al, MIT Press. It also provide functionality specific to MPI and not present in vtkMultiProcessController. Before any MPI communication can occur Initialize() must be called by all processes. It is required to be called once, controllers created after this need not call Initialize(). At the end of the program Finalize() must be called by all processes. The use of user-defined communicators are supported with vtkMPICommunicator and vtkMPIGroup. Note that a duplicate of the user defined communicator is used for internal communications (RMIs). This communicator has the same properties as the user one except that it has a new context which prevents the two communicators from interfering with each other.

See also:
  vtkOutputPort vtkInputPort vtkMultiProcessController vtkMPICommunicator vtkMPIGroup

Created by:
  - Geveci, Berk

CVS contributions (if > 5%):
  - Geveci, Berk (88%)

CVS logs (CVSweb):
  - .`h` (`/Parallel/vtkMPIController.h)`
  - .`cxx` (`/Parallel/vtkMPIController.cxx)`

Examples:
  vtkMPIController (Examples)

Tests:
  vtkMPIController (Tests)

Definition at line 71 of file vtkMPIController.h.

## Public Types
typedef vtkMultiProcessController | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | Initialize (int *vtkNotUsed(argc), char ***vtkNotUsed(argv), int initializedExternally)
virtual void | Finalize ()
virtual void | Finalize (int finalizedExternally)
virtual void | SingleMethodExecute ()
virtual void | MultipleMethodExecute ()
void | Barrier ()
virtual void | CreateOutputWindow ()
void | SetCommunicator (vtkMPICommunicator *comm)
virtual void | Initialize (int *argc, char ***argv)
int | NoBlockSend (int *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockSend (unsigned long *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockSend (char *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockSend (float *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockReceive (int *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockReceive (unsigned long *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockReceive (char *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
int | NoBlockReceive (float *data, int length, int remoteProcessId, int tag, vtkMPICommunicator::Request &req)
## Static Public Methods
vtkMPIController * | New ()
int | IsTypeOf (const char *type)
vtkMPIController * | SafeDownCast (vtkObject *o)
char * | ErrorString (int err)
const char * | GetProcessorName ()
## Protected Methods
| vtkMPIController ()
| ~vtkMPIController ()
int | InitializeNumberOfProcesses ()
void | InitializeCommunicator (vtkMPICommunicator *comm)
void | InitializeRMICommunicator ()
## Static Protected Attributes
vtkMPICommunicator * | WorldRMICommunicator
int | Initialized
char | ProcessorName []

## Member Typedef Documentation

typedef vtkMultiProcessController vtkMPIController::Superclass

| Reimplemented from vtkMultiProcessController. Definition at line 77 of file vtkMPIController.h.

## Constructor & Destructor Documentation

vtkMPIController::vtkMPIController | ( |  | ) | `[protected]`

vtkMPIController::~vtkMPIController | ( |  | ) | `[protected]`

## Member Function Documentation

vtkMPIController* vtkMPIController::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkMultiProcessController.

virtual const char* vtkMPIController::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkMultiProcessController.

int vtkMPIController::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkMultiProcessController.

virtual int vtkMPIController::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkMultiProcessController.

vtkMPIController* vtkMPIController::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkMultiProcessController.

void vtkMPIController::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkMultiProcessController.

virtual void vtkMPIController::Initialize | ( | int * | argc,
|  | char *** | argv
| ) | `[inline, virtual]`

| This method is for setting up the processes. It needs to be called only once during program execution. Calling it more than once will have no effect. Controllers created after this call will be initialized automatically (i.e. they will have the proper LocalProcessId and NumberOfProcesses). The addresses of argc and argv should be passed to this method otherwise command line arguments will not be correct (because usually MPI implementations add their own arguments during startup). Definition at line 89 of file vtkMPIController.h. References vtkMultiProcessController::Initialize().

virtual void vtkMPIController::Initialize | ( | int * | vtkNotUsed(argc),
|  | char *** | vtkNotUsed(argv),
|  | int | initializedExternally
| ) | `[virtual]`

| This method is for setting up the processes. If a subclass needs to initialize process communication (i.e. MPI) it would over ride this method. Provided for initialization outside vtk. Implements vtkMultiProcessController.

virtual void vtkMPIController::Finalize | ( |  | ) | `[inline, virtual]`

| This method is for cleaning up and has to be called before the end of the program if MPI was initialized with Initialize() Implements vtkMultiProcessController. Definition at line 98 of file vtkMPIController.h. References vtkMultiProcessController::Finalize().

virtual void vtkMPIController::Finalize | ( | int | finalizedExternally | ) | `[virtual]`

| This method is for cleaning up. If a subclass needs to clean up process communication (i.e. MPI) it would over ride this method. Provided for finalization outside vtk. Implements vtkMultiProcessController.

virtual void vtkMPIController::SingleMethodExecute | ( |  | ) | `[virtual]`

| Execute the SingleMethod (as define by SetSingleMethod) using this->NumberOfProcesses processes. Implements vtkMultiProcessController.

virtual void vtkMPIController::MultipleMethodExecute | ( |  | ) | `[virtual]`

| Execute the MultipleMethods (as define by calling SetMultipleMethod for each of the required this->NumberOfProcesses methods) using this->NumberOfProcesses processes. Implements vtkMultiProcessController.

void vtkMPIController::Barrier | ( |  | ) | `[virtual]`

| This method can be used to synchronize MPI processes in the current communicator. This uses the user communicator. Implements vtkMultiProcessController.

virtual void vtkMPIController::CreateOutputWindow | ( |  | ) | `[virtual]`

| This method can be used to tell the controller to create a special output window in which all messages are preceded by the process id. Implements vtkMultiProcessController.

char* vtkMPIController::ErrorString | ( | int | err | ) | `[static]`

| Given an MPI error code, return a string which contains an error message. This string has to be freed by the user.

void vtkMPIController::SetCommunicator | ( | vtkMPICommunicator * | comm | ) |

| MPIController uses this communicator in all sends and receives. By default, MPI_COMM_WORLD is used. THIS SHOULD ONLY BE CALLED ON THE PROCESSES INCLUDED IN THE COMMUNICATOR. FOR EXAMPLE, IF THE COMMUNICATOR CONTAINES PROCESSES 0 AND 1, INVOKING THIS METHOD ON ANY OTHER PROCESS WILL CAUSE AN MPI ERROR AND POSSIBLY LEAD TO A CRASH.

int vtkMPIController::NoBlockSend | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 139 of file vtkMPIController.h.

int vtkMPIController::NoBlockSend | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 143 of file vtkMPIController.h.

int vtkMPIController::NoBlockSend | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 147 of file vtkMPIController.h.

int vtkMPIController::NoBlockSend | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 151 of file vtkMPIController.h.

int vtkMPIController::NoBlockReceive | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 162 of file vtkMPIController.h.

int vtkMPIController::NoBlockReceive | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 166 of file vtkMPIController.h.

int vtkMPIController::NoBlockReceive | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 171 of file vtkMPIController.h.

int vtkMPIController::NoBlockReceive | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | vtkMPICommunicator::Request & | req
| ) | `[inline]`

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message. Note: These methods delegate to the communicator Definition at line 175 of file vtkMPIController.h.

const char* vtkMPIController::GetProcessorName | ( |  | ) | `[static]`

int vtkMPIController::InitializeNumberOfProcesses | ( |  | ) | `[protected]`

void vtkMPIController::InitializeCommunicator | ( | vtkMPICommunicator * | comm | ) | `[protected]`

void vtkMPIController::InitializeRMICommunicator | ( |  | ) | `[protected]`

## Member Data Documentation

vtkMPICommunicator* vtkMPIController::WorldRMICommunicator`[static, protected]`

| Definition at line 206 of file vtkMPIController.h.

int vtkMPIController::Initialized`[static, protected]`

| Definition at line 209 of file vtkMPIController.h.

char vtkMPIController::ProcessorName[]`[static, protected]`

| Definition at line 211 of file vtkMPIController.h.

The documentation for this class was generated from the following file:

- Parallel/vtkMPIController.h